comment*======================================================
	=	Animation Example by Mincho Georgiev 	     =
	=			2005			     =
	======================================================*
	
	include \masm32\include\windows.inc
	include \masm32\include\kernel32.inc
	include \masm32\include\user32.inc
	include	\masm32\include\gdi32.inc

	includelib \masm32\lib\kernel32.lib
	includelib \masm32\lib\user32.lib
	includelib \masm32\lib\gdi32.lib



	WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD
	WndProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
	EraseBall PROTO :DWORD
	UpdateBall PROTO :DWORD
	DrawBall PROTO :DWORD

.data?
hInstance HINSTANCE ?
hbmBall DWORD ?
hbmMask DWORD ?
bm BITMAP <>
ballX DWORD ?
ballY DWORD ?

deltaX DWORD ?
deltaY DWORD ?

.data
ClassName db"WINDOW_CLASS",0
DspName	  db"Application",0


deltaValue dd 4
nTimerDelay dd 10

.const
idTimer1 dd 1

.code
start:
	mov hInstance,FUNC(GetModuleHandle,NULL)
	invoke WinMain,hInstance,0,0,SW_SHOWDEFAULT
	invoke ExitProcess,NULL

WinMain PROC hInst:DWORD,hPrevinst:DWORD,hCmdLine:DWORD,nCmdShow:DWORD

	LOCAL wc :WNDCLASSEX
	LOCAL msg :MSG
	LOCAL hWin :HANDLE
	
	mov wc.cbSize,sizeof WNDCLASSEX
	mov wc.style,CS_HREDRAW or CS_VREDRAW
	mov wc.lpfnWndProc,OFFSET WndProc
	mov wc.cbClsExtra,0
	mov wc.cbWndExtra,0
	m2m wc.hInstance,hInst
	mov wc.hIcon,FUNC(LoadIcon,hInstance,500)
	mov wc.hCursor,FUNC(LoadCursor,hInstance,IDC_ARROW)
	mov wc.hbrBackground,COLOR_WINDOW+1
	mov wc.lpszMenuName,NULL
	mov wc.lpszClassName,OFFSET ClassName
	mov wc.hIconSm,NULL

	invoke RegisterClassEx,ADDR wc
	invoke CreateWindowEx,0,ADDR ClassName,ADDR DspName,
				WS_OVERLAPPEDWINDOW or CW_USEDEFAULT,400,400,
				320,240,NULL,NULL,hInst,NULL
	mov hWin,eax
	invoke ShowWindow,hWin,nCmdShow
	invoke UpdateWindow,hWin
	.repeat
		invoke GetMessage,ADDR msg,hWin,0,0
		.break .if (!eax)
		invoke TranslateMessage,ADDR msg
		invoke DispatchMessage,ADDR msg
		.until FALSE

	mov eax,msg.wParam
ret
WinMain ENDP

WndProc PROC hwnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	
	LOCAL hdcWindow :HDC
	LOCAL ps :PAINTSTRUCT
	
	.if uMsg==WM_CREATE
		
		mov hbmBall,FUNC(LoadBitmap,hInstance,600)
		mov hbmMask,FUNC(LoadBitmap,hInstance,700)
		invoke GetObject,hbmBall,sizeof BITMAP,ADDR bm
		invoke SetTimer,hwnd,idTimer1,nTimerDelay,NULL
		mov ballX,0
		mov ballY,0
		m2m deltaX,deltaValue
		m2m deltaY,deltaValue
		
	.elseif uMsg==WM_TIMER
		
		mov hdcWindow,FUNC(GetDC,hwnd)
		invoke EraseBall,hdcWindow
		invoke UpdateBall,hwnd
		invoke DrawBall,hdcWindow
		invoke ReleaseDC,hwnd,hdcWindow	
		
	.elseif uMsg==WM_PAINT
		
		mov hdcWindow,FUNC(BeginPaint,hwnd,ADDR ps)
		invoke DrawBall,hdcWindow
		invoke EndPaint,hwnd,ADDR ps	
	
	.elseif uMsg==WM_CLOSE
	
		invoke DestroyWindow,hwnd
		invoke ExitProcess,NULL
	
	.elseif uMsg==WM_DESTROY
	
		invoke KillTimer,hwnd,idTimer1
		invoke DeleteObject,hbmBall
		invoke DeleteObject,hbmMask
		invoke PostQuitMessage,NULL

	.endif
	invoke DefWindowProc,hwnd,uMsg,wParam,lParam
ret
WndProc ENDP
EraseBall PROC hdc :HDC
	
	LOCAL rc :RECT
	
	m2m rc.left,ballX
	m2m rc.top,ballY
	mov eax,ballX
	add eax,bm.bmWidth
	mov rc.right,eax
	mov eax,ballY
	add eax,bm.bmHeight
	mov rc.bottom,eax
	invoke FillRect,hdc,ADDR rc,COLOR_WINDOW+1

ret
EraseBall ENDP

DrawBall PROC hdc: HDC
	
	LOCAL hdcMemory :HDC
	
	mov hdcMemory,FUNC(CreateCompatibleDC,hdc)
	invoke SelectObject,hdcMemory,hbmMask
	invoke BitBlt,hdc,ballX,ballY,bm.bmWidth,bm.bmHeight,hdcMemory,0,0,SRCAND
	invoke SelectObject,hdcMemory,hbmBall
	invoke BitBlt,hdc,ballX,ballY,bm.bmWidth,bm.bmHeight,hdcMemory,0,0,SRCPAINT
	invoke DeleteDC,hdcMemory
ret
DrawBall ENDP

UpdateBall PROC hwnd:DWORD
	
	LOCAL rc :RECT
	
	invoke GetClientRect,hwnd,ADDR rc

	.if ballX > 65535
		mov ballX,0
		m2m deltaX,deltaValue
	.endif
	
	.if ballY > 65535
		mov ballY,0
		m2m deltaY,deltaValue
	.endif
	
	mov eax,ballX
	mov edx,deltaX
	add eax,edx
	mov ballX,eax
	mov eax,ballY
	mov edx,deltaY
	add eax,edx
	mov ballY,eax

	mov eax,ballX
	mov edx,bm.bmWidth
	add eax,edx

	.if eax > rc.right
		mov eax,rc.right
		mov edx,bm.bmWidth
		sub eax,edx
		mov ballX,eax
		mov eax,0
		sub eax,deltaValue
		mov deltaX,eax	
	.endif	

	mov eax,ballY
	mov edx,bm.bmHeight
	add eax,edx

	.if eax > rc.bottom
		mov eax,rc.bottom
		mov edx,bm.bmHeight
		sub eax,edx
		mov ballY,eax
		mov eax,0
		sub eax,deltaValue
		mov deltaY,eax
	.endif

ret
UpdateBall ENDP
end start
